(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('hammerjs'), require('@angular/platform-browser')) :
	typeof define === 'function' && define.amd ? define(['exports', '@angular/core', 'hammerjs', '@angular/platform-browser'], factory) :
	(factory((global.ng = global.ng || {}, global.ng.carrouselModule = {}),global.ng.core,global.hammerjs,global.ng['platform-browser']));
}(this, (function (exports,core,Hammer,platformBrowser) { 'use strict';

/**
 * :tmtfactory) © 2017
 * Alex Marcos <alejandro.marcos@tmtfactory.com>
 * @ignore
 */
var Carousel = (function () {
    function Carousel() {
        this._currdeg = 0;
        this._totalItems = 0;
        this._maxSize = 0;
        this._maxDegree = 0;
        this._totalWidth = 0;
        this._items = [];
        this._degreesSlides = [];
        this._currentIndex = 0;
        this._lastIndex = -1;
        this._lockSlides = false;
    }
    Object.defineProperty(Carousel.prototype, "currdeg", {
        get: function () {
            return this._currdeg;
        },
        set: function (value) {
            this._currdeg = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Carousel.prototype, "totalItems", {
        get: function () {
            return this._totalItems;
        },
        set: function (value) {
            this._totalItems = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Carousel.prototype, "maxSize", {
        get: function () {
            return this._maxSize;
        },
        set: function (value) {
            this._maxSize = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Carousel.prototype, "maxDegree", {
        get: function () {
            return this._maxDegree;
        },
        set: function (value) {
            this._maxDegree = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Carousel.prototype, "totalWidth", {
        get: function () {
            return this._totalWidth;
        },
        set: function (value) {
            this._totalWidth = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Carousel.prototype, "items", {
        get: function () {
            return this._items;
        },
        set: function (value) {
            this._items = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Carousel.prototype, "degreesSlides", {
        get: function () {
            return this._degreesSlides;
        },
        set: function (value) {
            this._degreesSlides = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Carousel.prototype, "currentIndex", {
        get: function () {
            return this._currentIndex;
        },
        set: function (value) {
            this._currentIndex = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Carousel.prototype, "lockSlides", {
        get: function () {
            return this._lockSlides;
        },
        set: function (value) {
            this._lockSlides = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Carousel.prototype, "lastIndex", {
        get: function () {
            return this._lastIndex;
        },
        set: function (value) {
            this._lastIndex = value;
        },
        enumerable: true,
        configurable: true
    });
    return Carousel;
}());

// TODO: move chart.js to it's own component
var CarouselComponent = (function () {
    function CarouselComponent() {
        this.carousel = new Carousel();
        this.morePairSlides = 1;
        this.angle = 45;
        this.ratioScale = 1;
        this.margin = 20;
        this.perspective = 2000;
        this.endInSlide = true;
        this.timeToSlide = 300;
        this.lockSlides = false;
        this.initialSlide = 0;
        this.onSlideChangeStart = new core.EventEmitter();
        this.onSlideChangeEnd = new core.EventEmitter();
        this.onSlideNextStart = new core.EventEmitter();
        this.onSlideNextEnd = new core.EventEmitter();
        this.onSlidePrevStart = new core.EventEmitter();
        this.onSlidePrevEnd = new core.EventEmitter();
        this.onTouchMove = new core.EventEmitter();
        this.onTouchStart = new core.EventEmitter();
        this.onTouchEnd = new core.EventEmitter();
        this.onTransitionStart = new core.EventEmitter();
        this.onTransitionEnd = new core.EventEmitter();
    }
    CarouselComponent.prototype.ngOnInit = function () {
    };
    CarouselComponent.prototype.ngAfterViewInit = function () {
        this.configPlugin();
        console.log(this);
    };
    CarouselComponent.prototype.slideNext = function () {
        if (this.checkLimitsCarrousel(this.carousel.currentIndex + 1)) {
            this.moveSlideTo(this.carousel.currentIndex + 1);
            var vm_1 = this;
            setTimeout(function () { return vm_1.detectCurrentSlide(); });
        }
    };
    CarouselComponent.prototype.slidePrev = function () {
        if (this.checkLimitsCarrousel(this.carousel.currentIndex - 1)) {
            this.moveSlideTo(this.carousel.currentIndex - 1);
            var vm_2 = this;
            setTimeout(function () { return vm_2.detectCurrentSlide(); });
        }
    };
    CarouselComponent.prototype.slideTo = function (index) {
        if (this.checkLimitsCarrousel(index)) {
            this.carousel.currentIndex = index;
            this.moveSlideTo(this.carousel.currentIndex);
            var vm_3 = this;
            setTimeout(function () { return vm_3.detectCurrentSlide(); });
        }
    };
    CarouselComponent.prototype.update = function () {
        this.carousel = new Carousel;
        this.configPlugin();
    };
    CarouselComponent.prototype.configPlugin = function () {
        this.setPerspectiveContainer();
        this.carousel.items = Array.from(this.carouselElm.nativeElement.getElementsByClassName("item-carousel"));
        this.carousel.totalItems = this.carousel.items.length;
        this.getmaxSizes();
        this.carousel.totalWidth = this.carousel.items.length * this.carousel.maxSize;
        this.carousel.lockSlides = this.lockSlides;
        this.setDegreesOnSlides();
        this.manageEvents();
        this.initSlidesOn();
        this.updateCssShowSlides();
    };
    CarouselComponent.prototype.rotate = function (e) {
        this.setNewDeg(this.carousel.currdeg + e.velocity);
        this.moveCarrousel(this.carousel.currdeg);
        if (e.isFinal) {
            if (this.endInSlide) {
                this.moveSlideTo(this.carousel.currentIndex);
            }
        }
    };
    CarouselComponent.prototype.initSlidesOn = function () {
        if (this.initialSlide >= 0 && this.initialSlide < this.carousel.items.length) {
            this.carousel.currentIndex = this.initialSlide;
            var newDeg = this.carousel.currentIndex * this.angle;
            this.setNewDeg(-newDeg);
            this.setTransformCarrousel(-newDeg);
        }
    };
    CarouselComponent.prototype.setNewDeg = function (newDeg) {
        this.carousel.currdeg = newDeg;
        if (this.carousel.currdeg > 0) {
            this.carousel.currdeg = 0;
        }
        if (this.carousel.currdeg < -this.carousel.maxDegree) {
            this.carousel.currdeg = -this.carousel.maxDegree;
        }
    };
    CarouselComponent.prototype.checkLimitsCarrousel = function (index) {
        return this.carousel.currentIndex != index && index >= 0 && index < this.carousel.totalItems;
    };
    CarouselComponent.prototype.moveSlideTo = function (index) {
        this.setNewDeg(-this.carousel.degreesSlides[index]);
        this.moveCarrousel(this.carousel.currdeg, this.timeToSlide);
    };
    CarouselComponent.prototype.moveCarrousel = function (deg, timeTransform) {
        if (timeTransform === void 0) { timeTransform = 0; }
        if (!this.carousel.lockSlides) {
            this.carouselElm.nativeElement.style.transition = "transform " + timeTransform + "ms";
            this.carouselElm.nativeElement.style.webkitTransition = "transform " + timeTransform + "ms";
            this.setTransformCarrousel(deg);
            this.detectCurrentSlide();
        }
    };
    CarouselComponent.prototype.setTransformCarrousel = function (deg) {
        this.carouselElm.nativeElement.style.transform = "rotateY(" + deg + "deg)";
        this.carouselElm.nativeElement.style.webkitTransform = "rotateY(" + deg + "deg)";
    };
    CarouselComponent.prototype.setPerspectiveContainer = function () {
        this.containerElm.nativeElement.style.perspective = this.perspective;
        this.containerElm.nativeElement.style.webkitPerspective = this.perspective;
    };
    CarouselComponent.prototype.getmaxSizes = function () {
        var _this = this;
        this.carousel.items.map(function (val) {
            var witdh = val.clientWidth;
            if (witdh > _this.carousel.maxSize) {
                _this.carousel.maxSize = witdh;
            }
        });
    };
    CarouselComponent.prototype.setDegreesOnSlides = function () {
        var _this = this;
        var auxDegree = 0;
        var scale = (1 + (this.carousel.maxSize * -1) / this.perspective) * this.ratioScale;
        var tz = (Math.round((this.carousel.maxSize / 2) /
            Math.tan(Math.PI / (360 / this.angle))) + this.margin) * scale;
        this.carousel.items.map(function (val, index) {
            val.style.width = _this.carousel.maxSize;
            val.style.transform = "rotateY(" + auxDegree + "deg) translateZ(" + (tz) + "px) scale(" + scale + ")";
            val.style.webkitTransform = "rotateY(" + auxDegree + "deg) translateZ(" + (tz) + "px) scale(" + scale + ")";
            _this.carousel.degreesSlides.push(auxDegree);
            _this.carousel.maxDegree = auxDegree;
            auxDegree += _this.angle;
        });
    };
    CarouselComponent.prototype.detectCurrentSlide = function () {
        var _this = this;
        var aux = 99e9;
        var index = 0;
        this.carousel.degreesSlides.forEach(function (val, i) {
            var res = Math.abs(val - Math.abs(_this.carousel.currdeg));
            if (res < aux) {
                aux = res;
                index = i;
            }
        });
        if (this.carousel.currentIndex != index) {
            this.carousel.lastIndex = this.carousel.currentIndex;
            this.carousel.currentIndex = index;
            this.updateCssShowSlides();
        }
    };
    CarouselComponent.prototype.updateCssShowSlides = function () {
        var vm = this;
        var currentIndex = vm.carousel.currentIndex;
        var actual = this.carousel.items[currentIndex];
        vm.removeClassShowSlides("actual");
        vm.removeClassShowSlides("prev");
        vm.removeClassShowSlides("next");
        if (actual) {
            actual.className += " actual";
        }
        for (var x = 0; x < this.morePairSlides; x++) {
            var prev = vm.carousel.items[currentIndex - (x + 1)];
            var next = vm.carousel.items[currentIndex + (x + 1)];
            if (prev) {
                prev.className += " prev";
            }
            if (next) {
                next.className += " next";
            }
        }
    };
    CarouselComponent.prototype.removeClassShowSlides = function (tagClass) {
        if (this.carouselElm.nativeElement.getElementsByClassName(tagClass).length > 0) {
            Array.from(this.carouselElm.nativeElement.getElementsByClassName(tagClass)).map(function (val) {
                val['classList'].remove(tagClass);
            });
        }
    };
    CarouselComponent.prototype.manageEvents = function () {
        var _this = this;
        var options = {
            preventDefault: true
        };
        var vm = this;
        var hammertime = new Hammer(this.carouselElm.nativeElement, options);
        hammertime.on("pan", function (e) {
            var elm = { carousel: vm.carousel, event: e };
            vm.onTouchMove.emit(elm);
            if (e.isFinal) {
                vm.onTouchEnd.emit(elm);
            }
            else if (e.isFirst) {
                vm.onSlideChangeStart.emit(elm);
                vm.onTouchStart.emit(elm);
                if (e.direction === Hammer.DIRECTION_LEFT) {
                    vm.onSlideNextStart.emit(elm);
                }
                else if (e.direction === Hammer.DIRECTION_RIGHT) {
                    vm.onSlidePrevStart.emit(elm);
                }
            }
        });
        this.carouselElm.nativeElement.addEventListener('transitionend', function (e) {
            var elm = { carousel: vm.carousel, event: e };
            if (e.propertyName === "transform") {
                _this.onTransitionEnd.emit(elm);
                _this.onSlideChangeEnd.emit(elm);
                if (vm.carousel.lastIndex > vm.carousel.currentIndex) {
                    _this.onSlideNextEnd.emit(elm);
                }
                else {
                    _this.onSlidePrevEnd.emit(elm);
                }
            }
        });
        this.carouselElm.nativeElement.addEventListener('transitionstart', function (ev) {
            console.log(ev);
        });
    };
    CarouselComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'carousel-component',
                    styles: ["\n        :host{\n            display: flex;\n        }\n        :host .container {\n            margin: 0 auto;\n            width: 600px;\n            height: 400px;\n            position: relative;\n        }\n\n\n        :host .container .carousel {\n            height: 100%;\n            width: 100%;\n            position: absolute;\n            transform-style: preserve-3d;\n        }\n\n        :host .container .carousel ::content >>> .item-carousel {\n            display: block;\n            position: absolute;\n            border:1px solid black;\n            width: 100%;\n            height: 100%;\n            text-align: center;\n            transform-style: preserve-3d;\n            overflow: hidden;\n            opacity: 0;\n            transition: opacity 300ms ease-in-out;\n        }\n        :host .container .carousel ::content >>> .item-carousel img{\n            user-drag: none;\n            user-select: none;\n            -moz-user-select: none;\n            -webkit-user-drag: none;\n            -webkit-user-select: none;\n            -ms-user-select: none;\n        }\n        :host .container .carousel ::content >>> .item-carousel.next,\n        :host .container .carousel ::content >>> .item-carousel.prev,\n        :host .container .carousel ::content >>> .item-carousel.actual{\n            opacity: 0.95;\n        }\n    "],
                    template: '<div class="container" #container>\n' +
                        '  <div class="carousel" #carousel (pan)="rotate($event)">\n' +
                        '    <!--<div class="item {{item.toLowerCase()}} {{updateCssShowSlides(i)}}" *ngFor="let item of data; let i = index">{{item}}</div>-->\n' +
                        '    <ng-content select=".item-carousel"></ng-content>\n' +
                        '  </div>\n' +
                        '</div>',
                },] },
    ];
    /** @nocollapse */
    CarouselComponent.ctorParameters = function () { return []; };
    CarouselComponent.propDecorators = {
        'morePairSlides': [{ type: core.Input, args: ["morePairSlides",] },],
        'angle': [{ type: core.Input, args: ["angle",] },],
        'ratioScale': [{ type: core.Input, args: ["ratioScale",] },],
        'margin': [{ type: core.Input, args: ["margin",] },],
        'perspective': [{ type: core.Input, args: ["perspective",] },],
        'endInSlide': [{ type: core.Input, args: ["endInSlide",] },],
        'timeToSlide': [{ type: core.Input, args: ["timeToSlide",] },],
        'lockSlides': [{ type: core.Input, args: ["lockSlides",] },],
        'initialSlide': [{ type: core.Input, args: ["initialSlide",] },],
        'onSlideChangeStart': [{ type: core.Output, args: ["onSlideChangeStart",] },],
        'onSlideChangeEnd': [{ type: core.Output, args: ["onSlideChangeEnd",] },],
        'onSlideNextStart': [{ type: core.Output, args: ["onSlideNextStart",] },],
        'onSlideNextEnd': [{ type: core.Output, args: ["onSlideNextEnd",] },],
        'onSlidePrevStart': [{ type: core.Output, args: ["onSlidePrevStart",] },],
        'onSlidePrevEnd': [{ type: core.Output, args: ["onSlidePrevEnd",] },],
        'onTouchMove': [{ type: core.Output, args: ["onTouchMove",] },],
        'onTouchStart': [{ type: core.Output, args: ["onTouchStart",] },],
        'onTouchEnd': [{ type: core.Output, args: ["onTouchEnd",] },],
        'onTransitionStart': [{ type: core.Output, args: ["onTransitionStart",] },],
        'onTransitionEnd': [{ type: core.Output, args: ["onTransitionEnd",] },],
        'carouselElm': [{ type: core.ViewChild, args: ["carousel",] },],
        'containerElm': [{ type: core.ViewChild, args: ["container",] },],
    };
    return CarouselComponent;
}());

/**
 * :tmtfactory) © 2017
 * Alex Marcos <alejandro.marcos@tmtfactory.com>
 * @ignore
 */
var __extends = (undefined && undefined.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var MyHammerConfig = (function (_super) {
    __extends(MyHammerConfig, _super);
    function MyHammerConfig() {
        _super.apply(this, arguments);
        this.overrides = {
            'swipe': { direction: Hammer.DIRECTION_ALL },
            'pan': { direction: Hammer.DIRECTION_HORIZONTAL } // override default settings
        };
    }
    return MyHammerConfig;
}(platformBrowser.HammerGestureConfig));
var CarouselModule = (function () {
    function CarouselModule() {
    }
    CarouselModule.decorators = [
        { type: core.NgModule, args: [{
                    declarations: [
                        CarouselComponent
                    ],
                    providers: [
                        {
                            provide: platformBrowser.HAMMER_GESTURE_CONFIG,
                            useClass: MyHammerConfig
                        }
                    ],
                    exports: [CarouselComponent],
                    schemas: [core.CUSTOM_ELEMENTS_SCHEMA]
                },] },
    ];
    /** @nocollapse */
    CarouselModule.ctorParameters = function () { return []; };
    return CarouselModule;
}());

/**
 * @module
 * @description
 * Entry point for all public APIs of the Angular Module
 */

exports.CarouselModule = CarouselModule;
exports.CarouselComponent = CarouselComponent;

Object.defineProperty(exports, '__esModule', { value: true });

})));
